from netgen.geom2d import unit_square
from ngsolve import *

mesh = Mesh(unit_square.GenerateMesh(maxh=0.2))

fes = H1(mesh, order=1)
gfu = GridFunction(fes, nested=False)

gfu.Set (x*y)
Draw(gfu)

# save the values
hv = gfu.vec.CreateVector()
hv.data = gfu.vec

mesh.Refine()
fes.Update()

# either prolongate, or 0-initialize, depending on 'nested' flag
gfu.Update()  

# copy values back, and prolongate
prol = fes.Prolongation()
gfu.vec.Range(0,len(hv)).data = hv
prol.Prolongate(1, gfu.vec)

Redraw()


